package net.mcreator.wjbs_biome_pack;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.client.event.ModelRegistryEvent;

import net.minecraft.potion.PotionEffect;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemFood;
import net.minecraft.item.Item;
import net.minecraft.item.EnumAction;
import net.minecraft.init.MobEffects;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;

public class MCreatorGlowshroomsoup extends wjbs_biome_pack.ModElement {

	@GameRegistry.ObjectHolder("wjbs_biome_pack:glowshroomsoup")
	public static final Item block = null;

	public MCreatorGlowshroomsoup(wjbs_biome_pack instance) {
		super(instance);
		instance.items.add(() -> new ItemFoodCustom());
	}

	@SideOnly(Side.CLIENT)
	@Override
	public void registerModels(ModelRegistryEvent event) {
		ModelLoader.setCustomModelResourceLocation(block, 0, new ModelResourceLocation("wjbs_biome_pack:glowshroomsoup", "inventory"));
	}

	public static class ItemFoodCustom extends ItemFood {

		public ItemFoodCustom() {
			super(6, 0.3F, false);
			setUnlocalizedName("glowshroomsoup");
			setRegistryName("glowshroomsoup");
			setPotionEffect(new PotionEffect(MobEffects.NIGHT_VISION, 600, 0), 1.0F);
			setCreativeTab(CreativeTabs.FOOD);
			setMaxStackSize(0);
		}

		@Override
		public EnumAction getItemUseAction(ItemStack par1ItemStack) {
			return EnumAction.DRINK;
		}
	}
}
