package net.mcreator.wjbs_biome_pack;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.common.registry.EntityEntry;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.network.IGuiHandler;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.SidedProxy;
import net.minecraftforge.fml.common.Mod.Instance;
import net.minecraftforge.fml.common.Mod.EventHandler;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.IWorldGenerator;
import net.minecraftforge.fml.common.IFuelHandler;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.client.event.ModelRegistryEvent;

import net.minecraft.world.gen.IChunkGenerator;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.util.ResourceLocation;
import net.minecraft.potion.Potion;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.block.Block;

import java.util.function.Supplier;
import java.util.Random;
import java.util.List;
import java.util.ArrayList;

@Mod(modid = wjbs_biome_pack.MODID, version = wjbs_biome_pack.VERSION, dependencies = "required-after:forge@[14.23.5.2768]")
public class wjbs_biome_pack implements IFuelHandler, IWorldGenerator {

	public static final String MODID = "wjbs_biome_pack";
	public static final String VERSION = "1.0.0";
	@SidedProxy(clientSide = "net.mcreator.wjbs_biome_pack.ClientProxywjbs_biome_pack", serverSide = "net.mcreator.wjbs_biome_pack.CommonProxywjbs_biome_pack")
	public static CommonProxywjbs_biome_pack proxy;
	@Instance(MODID)
	public static wjbs_biome_pack instance;
	public final List<ModElement> elements = new ArrayList<>();
	public final List<Supplier<Block>> blocks = new ArrayList<>();
	public final List<Supplier<Item>> items = new ArrayList<>();
	public final List<Supplier<Biome>> biomes = new ArrayList<>();
	public final List<Supplier<EntityEntry>> entities = new ArrayList<>();
	public final List<Supplier<Potion>> potions = new ArrayList<>();

	public wjbs_biome_pack() {
		FluidRegistry.enableUniversalBucket();
		elements.add(new MCreatorRainforestlog1(this));
		elements.add(new MCreatorRainforestleaves1(this));
		elements.add(new MCreatorRainforest(this));
		elements.add(new MCreatorRainforestspider(this));
		elements.add(new MCreatorRainforestplanks1(this));
		elements.add(new MCreatorRainforestplanksrecipe(this));
		elements.add(new MCreatorRainforestlogcraftingtable(this));
		elements.add(new MCreatorRainforeststickrecipe(this));
		elements.add(new MCreatorDryad1(this));
		elements.add(new MCreatorDryad2(this));
		elements.add(new MCreatorDryad3(this));
		elements.add(new MCreatorDryad4(this));
		elements.add(new MCreatorDryad5(this));
		elements.add(new MCreatorDryad6(this));
		elements.add(new MCreatorDryad7(this));
		elements.add(new MCreatorDryad8(this));
		elements.add(new MCreatorDryad9(this));
		elements.add(new MCreatorBurntdryad(this));
		elements.add(new MCreatorScorcheddirt(this));
		elements.add(new MCreatorScorched(this));
		elements.add(new MCreatorMushroomjungle(this));
		elements.add(new MCreatorMushroomjungleblueshroomtop(this));
		elements.add(new MCreatorGlowshroomsoup(this));
		elements.add(new MCreatorGlowshroomsouprecipe1(this));
		elements.add(new MCreatorScorchedzombie(this));
		elements.add(new MCreatorDryad10(this));
		elements.add(new MCreatorNewvillager1(this));
		elements.add(new MCreatorScorchedplants(this));
		elements.add(new MCreatorScorcheddirt2(this));
		elements.add(new MCreatorBlueshroom(this));
		elements.add(new MCreatorItemash(this));
		elements.add(new MCreatorOilore(this));
		elements.add(new MCreatorOil(this));
		elements.add(new MCreatorOiloreBlockDestroyedByPlayer(this));
		elements.add(new MCreatorOilitem(this));
		elements.add(new MCreatorWolf(this));
		elements.add(new MCreatorRubber(this));
		elements.add(new MCreatorRubberball(this));
		elements.add(new MCreatorRubberboots(this));
		elements.add(new MCreatorRubberbootsBootsTickEvent(this));
		elements.add(new MCreatorRubberblock(this));
		elements.add(new MCreatorRubberblockrecipe(this));
		elements.add(new MCreatorAutumnleaves(this));
		elements.add(new MCreatorAutumn(this));
		elements.add(new MCreatorRainforeststairs(this));
		elements.add(new MCreatorRainforeststairrecipe(this));
		elements.add(new MCreatorRainforestsword(this));
		elements.add(new MCreatorRainforestaxe(this));
		elements.add(new MCreatorRainforestpickaxe(this));
		elements.add(new MCreatorRainforestshovel(this));
		elements.add(new MCreatorRainforesthoe(this));
		elements.add(new MCreatorDarkgemore(this));
		elements.add(new MCreatorDarkgem(this));
		elements.add(new MCreatorDarkgemblock(this));
		elements.add(new MCreatorDarkgemsword(this));
		elements.add(new MCreatorDarkgemarmour(this));
		elements.add(new MCreatorSkelesteve(this));
		elements.add(new MCreatorLandofthedead(this));
		elements.add(new MCreatorZombiepig(this));
		elements.add(new MCreatorDeadfield(this));
		elements.add(new MCreatorOctopus(this));
		elements.add(new MCreatorToast(this));
		elements.add(new MCreatorToastkey(this));
		elements.add(new MCreatorDarkgembars(this));
		elements.add(new MCreatorDarkgembarsrecipe(this));
		elements.add(new MCreatorJadeblock(this));
		elements.add(new MCreatorJade(this));
		elements.add(new MCreatorJadeore(this));
		elements.add(new MCreatorJadedagger(this));
		elements.add(new MCreatorJadedaggerrecipe(this));
		elements.add(new MCreatorDarkgemswordrecipe(this));
		elements.add(new MCreatorDarkgemhelmetrecipe(this));
		elements.add(new MCreatorDarkgemchestplaterecipe(this));
		elements.add(new MCreatorDarkgemleggings(this));
		elements.add(new MCreatorDarkgemboots(this));
		elements.add(new MCreatorChestrecipe2(this));
		elements.add(new MCreatorDarknessbiome(this));
		elements.add(new MCreatorMoneyportal(this));
		elements.add(new MCreatorGlowflow(this));
		elements.add(new MCreatorGoldiamondore(this));
		elements.add(new MCreatorGoldiamondingot(this));
		elements.add(new MCreatorRainforestdoor(this));
		elements.add(new MCreatorRainforesttrapdoor(this));
		elements.add(new MCreatorRainforestfence(this));
		elements.add(new MCreatorHeadlesswanderer(this));
		elements.add(new MCreatorFossil(this));
		elements.add(new MCreatorShale(this));
		elements.add(new MCreatorDarkgemaxe(this));
		elements.add(new MCreatorDarkgempickaxe(this));
		elements.add(new MCreatorDarkgemhoe(this));
		elements.add(new MCreatorDarkgemshovel(this));
		elements.add(new MCreatorDarkaxegem(this));
		elements.add(new MCreatorDarkpickaxegem(this));
		elements.add(new MCreatorDarkhoegem(this));
		elements.add(new MCreatorJadeaxe(this));
		elements.add(new MCreatorJadepickaxe(this));
		elements.add(new MCreatorJadescythe(this));
		elements.add(new MCreatorJadeshovel(this));
		elements.add(new MCreatorJadeaxerecipe(this));
		elements.add(new MCreatorJadepickaxerecipe(this));
		elements.add(new MCreatorJadescytherecipe(this));
		elements.add(new MCreatorJadeshovelrecipe(this));
		elements.add(new MCreatorStonesword2(this));
		elements.add(new MCreatorStoneaxe2(this));
		elements.add(new MCreatorStonehoe2(this));
		elements.add(new MCreatorStonepickaxe2(this));
		elements.add(new MCreatorStoneshovel2(this));
		elements.add(new MCreatorCopperore(this));
		elements.add(new MCreatorCopperingot(this));
		elements.add(new MCreatorCopperwire(this));
		elements.add(new MCreatorIngottowire(this));
		elements.add(new MCreatorElectriclamp(this));
		elements.add(new MCreatorElectriclamprecip(this));
		elements.add(new MCreatorPowercore(this));
		elements.add(new MCreatorAlltoasters(this));
		elements.add(new MCreatorToastItemIsCraftedsmelted(this));
		elements.add(new MCreatorDarkgemshovelrecipe(this));
		elements.add(new MCreatorPowercellrecipe(this));
		elements.add(new MCreatorIronswordpolishing(this));
		elements.add(new MCreatorChainsaw(this));
		elements.add(new MCreatorChainsawrecipe(this));
		elements.add(new MCreatorChainsawpolish(this));
		elements.add(new MCreatorForgottenbiome(this));
		elements.add(new MCreatorForgottenzombie(this));
		elements.add(new MCreatorForgottenlog(this));
		elements.add(new MCreatorForgottenplanks(this));
		elements.add(new MCreatorForgottenleaves(this));
		elements.add(new MCreatorForgottenspider(this));
		elements.add(new MCreatorPeridot(this));
		elements.add(new MCreatorBlockofperidot(this));
		elements.add(new MCreatorPeridotore(this));
		elements.add(new MCreatorEndwater(this));
		elements.add(new MCreatorOnyx(this));
		elements.add(new MCreatorOnyxblock(this));
		elements.add(new MCreatorOnyxore(this));
		elements.add(new MCreatorPeridotblockrecipe(this));
		elements.add(new MCreatorOnyxblockrecipe(this));
		elements.add(new MCreatorDarkgemblockrecipe(this));
		elements.add(new MCreatorJadeblockrecipe(this));
		elements.add(new MCreatorCherryleaves(this));
		elements.add(new MCreatorCherrybiome(this));
		elements.add(new MCreatorCherry(this));
		elements.add(new MCreatorImrich(this));
		elements.add(new MCreatorFossilfuel(this));
		elements.add(new MCreatorForgottenplanksrecipe(this));
		elements.add(new MCreatorForgottengrass(this));
		elements.add(new MCreatorForgottendirt(this));
	}

	@Override
	public int getBurnTime(ItemStack fuel) {
		for (ModElement element : elements) {
			int ret = element.addFuel(fuel);
			if (ret != 0)
				return ret;
		}
		return 0;
	}

	@Override
	public void generate(Random random, int chunkX, int chunkZ, World world, IChunkGenerator cg, IChunkProvider cp) {
		elements.forEach(element -> element.generateWorld(random, chunkX * 16, chunkZ * 16, world, world.provider.getDimension(), cg, cp));
	}

	@SubscribeEvent
	public void registerBlocks(RegistryEvent.Register<Block> event) {
		event.getRegistry().registerAll(blocks.stream().map(Supplier::get).toArray(Block[]::new));
	}

	@SubscribeEvent
	public void registerItems(RegistryEvent.Register<Item> event) {
		event.getRegistry().registerAll(items.stream().map(Supplier::get).toArray(Item[]::new));
	}

	@SubscribeEvent
	public void registerBiomes(RegistryEvent.Register<Biome> event) {
		event.getRegistry().registerAll(biomes.stream().map(Supplier::get).toArray(Biome[]::new));
	}

	@SubscribeEvent
	public void registerEntities(RegistryEvent.Register<EntityEntry> event) {
		event.getRegistry().registerAll(entities.stream().map(Supplier::get).toArray(EntityEntry[]::new));
	}

	@SubscribeEvent
	public void registerPotions(RegistryEvent.Register<Potion> event) {
		event.getRegistry().registerAll(potions.stream().map(Supplier::get).toArray(Potion[]::new));
	}

	@SubscribeEvent
	public void registerSounds(RegistryEvent.Register<net.minecraft.util.SoundEvent> event) {
		ResourceLocation sound0 = new ResourceLocation("wjbs_biome_pack", "entity.headless.die");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound0).setRegistryName(sound0));
		ResourceLocation sound1 = new ResourceLocation("wjbs_biome_pack", "entity.headless.hurt");
		event.getRegistry().register(new net.minecraft.util.SoundEvent(sound1).setRegistryName(sound1));
	}

	@SubscribeEvent
	@SideOnly(Side.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		elements.forEach(element -> element.registerModels(event));
	}

	@EventHandler
	public void preInit(FMLPreInitializationEvent event) {
		MinecraftForge.EVENT_BUS.register(this);
		GameRegistry.registerFuelHandler(this);
		GameRegistry.registerWorldGenerator(this, 5);
		NetworkRegistry.INSTANCE.registerGuiHandler(this, new GuiHandler());
		elements.forEach(element -> element.preInit(event));
		proxy.preInit(event);
	}

	@EventHandler
	public void init(FMLInitializationEvent event) {
		elements.forEach(element -> element.init(event));
		proxy.init(event);
	}

	@EventHandler
	public void serverLoad(FMLServerStartingEvent event) {
		elements.forEach(element -> element.serverLoad(event));
	}

	public static class GuiHandler implements IGuiHandler {

		@Override
		public Object getServerGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			return null;
		}

		@Override
		public Object getClientGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			return null;
		}
	}

	public static class ModElement {

		public static wjbs_biome_pack instance;

		public ModElement(wjbs_biome_pack instance) {
			this.instance = instance;
		}

		public void init(FMLInitializationEvent event) {
		}

		public void preInit(FMLPreInitializationEvent event) {
		}

		public void generateWorld(Random random, int posX, int posZ, World world, int dimID, IChunkGenerator cg, IChunkProvider cp) {
		}

		public void serverLoad(FMLServerStartingEvent event) {
		}

		public void registerModels(ModelRegistryEvent event) {
		}

		public int addFuel(ItemStack fuel) {
			return 0;
		}
	}
}
