package net.mcreator.wjbs_biome_pack;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fluids.BlockFluidClassic;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.client.event.ModelRegistryEvent;

import net.minecraft.util.ResourceLocation;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.Item;
import net.minecraft.client.renderer.block.statemap.StateMapperBase;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.client.renderer.block.model.ModelBakery;
import net.minecraft.client.renderer.ItemMeshDefinition;
import net.minecraft.block.state.IBlockState;
import net.minecraft.block.material.Material;
import net.minecraft.block.Block;

public class MCreatorOil extends wjbs_biome_pack.ModElement {

	@GameRegistry.ObjectHolder("wjbs_biome_pack:oil")
	public static final Block block = null;
	@GameRegistry.ObjectHolder("wjbs_biome_pack:oil")
	public static final Item item = null;
	private Fluid fluid;

	public MCreatorOil(wjbs_biome_pack instance) {
		super(instance);
		fluid = new Fluid("oil", new ResourceLocation("wjbs_biome_pack:blocks/oilflow"), new ResourceLocation("wjbs_biome_pack:blocks/oilstill"))
				.setLuminosity(0).setDensity(1000).setViscosity(1000).setGaseous(false);
		FluidRegistry.registerFluid(fluid);
		instance.blocks.add(() -> new BlockFluidClassic(fluid, Material.WATER) {
		}.setUnlocalizedName("oil").setRegistryName("oil"));
		instance.items.add(() -> new ItemBlock(block).setRegistryName("oil"));
	}

	@Override
	public void preInit(FMLPreInitializationEvent event) {
		FluidRegistry.addBucketForFluid(fluid);
	}

	@Override
	@SideOnly(Side.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		ModelBakery.registerItemVariants(item);
		ModelLoader.setCustomMeshDefinition(item, new ItemMeshDefinition() {

			@Override
			public ModelResourceLocation getModelLocation(ItemStack stack) {
				return new ModelResourceLocation("wjbs_biome_pack:oil", "oil");
			}
		});
		ModelLoader.setCustomStateMapper(block, new StateMapperBase() {

			@Override
			protected ModelResourceLocation getModelResourceLocation(IBlockState state) {
				return new ModelResourceLocation("wjbs_biome_pack:oil", "oil");
			}
		});
	}
}
